Index: src/backend/rewrite/rewriteHandler.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/rewrite/rewriteHandler.c,v
retrieving revision 1.150
diff -c -r1.150 rewriteHandler.c
*** src/backend/rewrite/rewriteHandler.c	6 Apr 2005 16:34:06 -0000	1.150
--- src/backend/rewrite/rewriteHandler.c	18 Apr 2005 22:01:59 -0000
***************
*** 51,57 ****
  					TargetEntry *prior_tle,
  					const char *attrName);
  static Node *get_assignment_input(Node *node);
! static void markQueryForUpdate(Query *qry, bool skipOldNew);
  static List *matchLocks(CmdType event, RuleLock *rulelocks,
  		   int varno, Query *parsetree);
  static Query *fireRIRrules(Query *parsetree, List *activeRIRs);
--- 51,57 ----
  					TargetEntry *prior_tle,
  					const char *attrName);
  static Node *get_assignment_input(Node *node);
! static void markQueryForLocking(Query *qry, bool skipOldNew);
  static List *matchLocks(CmdType event, RuleLock *rulelocks,
  		   int varno, Query *parsetree);
  static Query *fireRIRrules(Query *parsetree, List *activeRIRs);
***************
*** 745,780 ****
  	rte->checkAsUser = 0;
  
  	/*
! 	 * FOR UPDATE of view?
  	 */
  	if (list_member_int(parsetree->rowMarks, rt_index))
  	{
  		/*
  		 * Remove the view from the list of rels that will actually be
! 		 * marked FOR UPDATE by the executor.  It will still be access-
  		 * checked for write access, though.
  		 */
  		parsetree->rowMarks = list_delete_int(parsetree->rowMarks, rt_index);
  
  		/*
! 		 * Set up the view's referenced tables as if FOR UPDATE.
  		 */
! 		markQueryForUpdate(rule_action, true);
  	}
  
  	return parsetree;
  }
  
  /*
!  * Recursively mark all relations used by a view as FOR UPDATE.
   *
   * This may generate an invalid query, eg if some sub-query uses an
   * aggregate.  We leave it to the planner to detect that.
   *
!  * NB: this must agree with the parser's transformForUpdate() routine.
   */
  static void
! markQueryForUpdate(Query *qry, bool skipOldNew)
  {
  	Index		rti = 0;
  	ListCell   *l;
--- 745,780 ----
  	rte->checkAsUser = 0;
  
  	/*
! 	 * FOR UPDATE/SHARE of view?
  	 */
  	if (list_member_int(parsetree->rowMarks, rt_index))
  	{
  		/*
  		 * Remove the view from the list of rels that will actually be
! 		 * marked FOR UPDATE/SHARE by the executor.  It will still be access-
  		 * checked for write access, though.
  		 */
  		parsetree->rowMarks = list_delete_int(parsetree->rowMarks, rt_index);
  
  		/*
! 		 * Set up the view's referenced tables as if FOR UPDATE/SHARE.
  		 */
! 		markQueryForLocking(rule_action, true);
  	}
  
  	return parsetree;
  }
  
  /*
!  * Recursively mark all relations used by a view as FOR UPDATE/SHARE.
   *
   * This may generate an invalid query, eg if some sub-query uses an
   * aggregate.  We leave it to the planner to detect that.
   *
!  * NB: this must agree with the parser's transformLockingClause() routine.
   */
  static void
! markQueryForLocking(Query *qry, bool skipOldNew)
  {
  	Index		rti = 0;
  	ListCell   *l;
***************
*** 798,805 ****
  		}
  		else if (rte->rtekind == RTE_SUBQUERY)
  		{
! 			/* FOR UPDATE of subquery is propagated to subquery's rels */
! 			markQueryForUpdate(rte->subquery, false);
  		}
  	}
  }
--- 798,805 ----
  		}
  		else if (rte->rtekind == RTE_SUBQUERY)
  		{
! 			/* FOR UPDATE/SHARE of subquery is propagated to subquery's rels */
! 			markQueryForLocking(rte->subquery, false);
  		}
  	}
  }
***************
*** 911,917 ****
  		 * If the relation is the query's result relation, then
  		 * RewriteQuery() already got the right lock on it, so we need no
  		 * additional lock. Otherwise, check to see if the relation is
! 		 * accessed FOR UPDATE or not.
  		 */
  		if (rt_index == parsetree->resultRelation)
  			lockmode = NoLock;
--- 911,917 ----
  		 * If the relation is the query's result relation, then
  		 * RewriteQuery() already got the right lock on it, so we need no
  		 * additional lock. Otherwise, check to see if the relation is
! 		 * accessed FOR UPDATE/SHARE or not.
  		 */
  		if (rt_index == parsetree->resultRelation)
  			lockmode = NoLock;
Index: src/backend/storage/ipc/ipci.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/storage/ipc/ipci.c,v
retrieving revision 1.74
diff -c -r1.74 ipci.c
*** src/backend/storage/ipc/ipci.c	31 Dec 2004 22:00:56 -0000	1.74
--- src/backend/storage/ipc/ipci.c	16 Apr 2005 18:17:18 -0000
***************
*** 15,20 ****
--- 15,21 ----
  #include "postgres.h"
  
  #include "access/clog.h"
+ #include "access/multixact.h"
  #include "access/subtrans.h"
  #include "access/xlog.h"
  #include "miscadmin.h"
***************
*** 75,80 ****
--- 76,82 ----
  		size += XLOGShmemSize();
  		size += CLOGShmemSize();
  		size += SUBTRANSShmemSize();
+ 		size += MultiXactShmemSize();
  		size += LWLockShmemSize();
  		size += SInvalShmemSize(maxBackends);
  		size += FreeSpaceShmemSize();
***************
*** 140,145 ****
--- 142,148 ----
  	XLOGShmemInit();
  	CLOGShmemInit();
  	SUBTRANSShmemInit();
+ 	MultiXactShmemInit();
  	InitBufferPool();
  
  	/*
Index: src/backend/storage/ipc/sinval.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/storage/ipc/sinval.c,v
retrieving revision 1.75
diff -c -r1.75 sinval.c
*** src/backend/storage/ipc/sinval.c	31 Dec 2004 22:00:56 -0000	1.75
--- src/backend/storage/ipc/sinval.c	18 Apr 2005 20:35:52 -0000
***************
*** 16,21 ****
--- 16,22 ----
  
  #include <signal.h>
  
+ #include "access/multixact.h"
  #include "access/subtrans.h"
  #include "access/transam.h"
  #include "commands/async.h"
***************
*** 1113,1115 ****
--- 1114,1164 ----
  }
  
  #endif   /* XIDCACHE_DEBUG */
+ 
+ /*
+  * GetNewMinMultiXact -- Get the new minimum MultiXactId
+  *
+  * Find out what the minimum MultiXactId of the remaining running
+  * transactions, that is, excluding myself.  It may very well be
+  * InvalidMultiXactId if no other transaction is using MultiXactIds.
+  *
+  * The caller should hold MultiXactGenLock so that no other backend
+  * can change its mxmin while this is running.
+  */
+ MultiXactId
+ GetNewMinMultiXact(void)
+ {
+ 	SISeg	   *segP = shmInvalBuffer;
+ 	ProcState  *stateP = segP->procState;
+ 	int			index;
+ 	MultiXactId	newMin = InvalidMultiXactId;
+ 
+ 	LWLockAcquire(SInvalLock, LW_SHARED);
+ 
+ 	for (index = 0; index < segP->lastBackend; index++)
+ 	{
+ 		SHMEM_OFFSET pOffset = stateP[index].procStruct;
+ 
+ 		if (pOffset != INVALID_OFFSET)
+ 		{
+ 			PGPROC	   *proc = (PGPROC *) MAKE_PTR(pOffset);
+ 
+ 			if (proc == MyProc)
+ 				continue;		/* skip myself */
+ 			if (proc->mxmin == InvalidMultiXactId)
+ 				continue;		/* skip non-MultiXact-using backends */
+ 			elog(NOTICE, "probando: proc->mxmin %u, min %u",
+ 					proc->mxmin, newMin);
+ 			if ((!MultiXactIdIsValid(newMin)) ||
+ 				 MultiXactIdPrecedes(proc->mxmin, newMin))
+ 			{
+ 				newMin = proc->mxmin;
+ 				elog(NOTICE, "ok! newmin: %u", newMin);
+ 			}
+ 		}
+ 	}
+ 
+ 	LWLockRelease(SInvalLock);
+ 
+ 	return newMin;
+ }
Index: src/backend/storage/lmgr/lwlock.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/storage/lmgr/lwlock.c,v
retrieving revision 1.27
diff -c -r1.27 lwlock.c
*** src/backend/storage/lmgr/lwlock.c	8 Apr 2005 14:18:35 -0000	1.27
--- src/backend/storage/lmgr/lwlock.c	18 Apr 2005 22:01:59 -0000
***************
*** 114,119 ****
--- 114,125 ----
  	/* subtrans.c needs one per SubTrans buffer */
  	numLocks += NUM_SLRU_BUFFERS;
  
+ 	/*
+ 	 * multixact.c needs one per MultiXact buffers, but there are
+ 	 * two SLRU areas for MultiXact
+ 	 */
+ 	numLocks += 2 * NUM_SLRU_BUFFERS;
+ 
  	/* Perhaps create a few more for use by user-defined modules? */
  
  	return numLocks;
Index: src/backend/tcop/utility.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/tcop/utility.c,v
retrieving revision 1.235
diff -c -r1.235 utility.c
*** src/backend/tcop/utility.c	14 Apr 2005 01:38:18 -0000	1.235
--- src/backend/tcop/utility.c	18 Apr 2005 22:02:00 -0000
***************
*** 1663,1669 ****
  			if (parsetree->into != NULL)
  				tag = "SELECT INTO";
  			else if (parsetree->rowMarks != NIL)
! 				tag = "SELECT FOR UPDATE";
  			else
  				tag = "SELECT";
  			break;
--- 1663,1674 ----
  			if (parsetree->into != NULL)
  				tag = "SELECT INTO";
  			else if (parsetree->rowMarks != NIL)
! 			{
! 				if (parsetree->forUpdate)
! 					tag = "SELECT FOR UPDATE";
! 				else
! 					tag = "SELECT FOR SHARE";
! 			}
  			else
  				tag = "SELECT";
  			break;
Index: src/backend/utils/adt/ri_triggers.c
===================================================================
RCS file: /home/alvherre/cvs/pgsql/src/backend/utils/adt/ri_triggers.c,v
retrieving revision 1.76
diff -c -r1.76 ri_triggers.c
*** src/backend/utils/adt/ri_triggers.c	31 Dec 2004 22:01:22 -0000	1.76
--- src/backend/utils/adt/ri_triggers.c	16 Apr 2005 18:17:17 -0000
***************
*** 206,212 ****
  	 * tuple.
  	 *
  	 * pk_rel is opened in RowShareLock mode since that's what our eventual
! 	 * SELECT FOR UPDATE will get on it.
  	 */
  	pk_rel = heap_open(trigdata->tg_trigger->tgconstrrelid, RowShareLock);
  	fk_rel = trigdata->tg_relation;
--- 206,212 ----
  	 * tuple.
  	 *
  	 * pk_rel is opened in RowShareLock mode since that's what our eventual
! 	 * SELECT FOR SHARE will get on it.
  	 */
  	pk_rel = heap_open(trigdata->tg_trigger->tgconstrrelid, RowShareLock);
  	fk_rel = trigdata->tg_relation;
***************
*** 267,273 ****
  			 * ----------
  			 */
  			quoteRelationName(pkrelname, pk_rel);
! 			snprintf(querystr, sizeof(querystr), "SELECT 1 FROM ONLY %s x FOR UPDATE OF x",
  					 pkrelname);
  
  			/* Prepare and save the plan */
--- 267,273 ----
  			 * ----------
  			 */
  			quoteRelationName(pkrelname, pk_rel);
! 			snprintf(querystr, sizeof(querystr), "SELECT 1 FROM ONLY %s x FOR SHARE OF x",
  					 pkrelname);
  
  			/* Prepare and save the plan */
***************
*** 428,434 ****
  			queryoids[i] = SPI_gettypeid(fk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_FK_IDX]);
  		}
! 		strcat(querystr, " FOR UPDATE OF x");
  
  		/* Prepare and save the plan */
  		qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
--- 428,434 ----
  			queryoids[i] = SPI_gettypeid(fk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_FK_IDX]);
  		}
! 		strcat(querystr, " FOR SHARE OF x");
  
  		/* Prepare and save the plan */
  		qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
***************
*** 590,596 ****
  			queryoids[i] = SPI_gettypeid(pk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_PK_IDX]);
  		}
! 		strcat(querystr, " FOR UPDATE OF x");
  
  		/* Prepare and save the plan */
  		qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
--- 590,596 ----
  			queryoids[i] = SPI_gettypeid(pk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_PK_IDX]);
  		}
! 		strcat(querystr, " FOR SHARE OF x");
  
  		/* Prepare and save the plan */
  		qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
***************
*** 655,661 ****
  	 * tuple.
  	 *
  	 * fk_rel is opened in RowShareLock mode since that's what our eventual
! 	 * SELECT FOR UPDATE will get on it.
  	 */
  	fk_rel = heap_open(trigdata->tg_trigger->tgconstrrelid, RowShareLock);
  	pk_rel = trigdata->tg_relation;
--- 655,661 ----
  	 * tuple.
  	 *
  	 * fk_rel is opened in RowShareLock mode since that's what our eventual
! 	 * SELECT FOR SHARE will get on it.
  	 */
  	fk_rel = heap_open(trigdata->tg_trigger->tgconstrrelid, RowShareLock);
  	pk_rel = trigdata->tg_relation;
***************
*** 748,754 ****
  					queryoids[i] = SPI_gettypeid(pk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_PK_IDX]);
  				}
! 				strcat(querystr, " FOR UPDATE OF x");
  
  				/* Prepare and save the plan */
  				qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
--- 748,754 ----
  					queryoids[i] = SPI_gettypeid(pk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_PK_IDX]);
  				}
! 				strcat(querystr, " FOR SHARE OF x");
  
  				/* Prepare and save the plan */
  				qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
***************
*** 834,840 ****
  	 * and old tuple.
  	 *
  	 * fk_rel is opened in RowShareLock mode since that's what our eventual
! 	 * SELECT FOR UPDATE will get on it.
  	 */
  	fk_rel = heap_open(trigdata->tg_trigger->tgconstrrelid, RowShareLock);
  	pk_rel = trigdata->tg_relation;
--- 834,840 ----
  	 * and old tuple.
  	 *
  	 * fk_rel is opened in RowShareLock mode since that's what our eventual
! 	 * SELECT FOR SHARE will get on it.
  	 */
  	fk_rel = heap_open(trigdata->tg_trigger->tgconstrrelid, RowShareLock);
  	pk_rel = trigdata->tg_relation;
***************
*** 939,945 ****
  					queryoids[i] = SPI_gettypeid(pk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_PK_IDX]);
  				}
! 				strcat(querystr, " FOR UPDATE OF x");
  
  				/* Prepare and save the plan */
  				qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
--- 939,945 ----
  					queryoids[i] = SPI_gettypeid(pk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_PK_IDX]);
  				}
! 				strcat(querystr, " FOR SHARE OF x");
  
  				/* Prepare and save the plan */
  				qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
***************
*** 1373,1379 ****
  	 * tuple.
  	 *
  	 * fk_rel is opened in RowShareLock mode since that's what our eventual
! 	 * SELECT FOR UPDATE will get on it.
  	 */
  	fk_rel = heap_open(trigdata->tg_trigger->tgconstrrelid, RowShareLock);
  	pk_rel = trigdata->tg_relation;
--- 1373,1379 ----
  	 * tuple.
  	 *
  	 * fk_rel is opened in RowShareLock mode since that's what our eventual
! 	 * SELECT FOR SHARE will get on it.
  	 */
  	fk_rel = heap_open(trigdata->tg_trigger->tgconstrrelid, RowShareLock);
  	pk_rel = trigdata->tg_relation;
***************
*** 1453,1459 ****
  					queryoids[i] = SPI_gettypeid(pk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_PK_IDX]);
  				}
! 				strcat(querystr, " FOR UPDATE OF x");
  
  				/* Prepare and save the plan */
  				qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
--- 1453,1459 ----
  					queryoids[i] = SPI_gettypeid(pk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_PK_IDX]);
  				}
! 				strcat(querystr, " FOR SHARE OF x");
  
  				/* Prepare and save the plan */
  				qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
***************
*** 1543,1549 ****
  	 * and old tuple.
  	 *
  	 * fk_rel is opened in RowShareLock mode since that's what our eventual
! 	 * SELECT FOR UPDATE will get on it.
  	 */
  	fk_rel = heap_open(trigdata->tg_trigger->tgconstrrelid, RowShareLock);
  	pk_rel = trigdata->tg_relation;
--- 1543,1549 ----
  	 * and old tuple.
  	 *
  	 * fk_rel is opened in RowShareLock mode since that's what our eventual
! 	 * SELECT FOR SHARE will get on it.
  	 */
  	fk_rel = heap_open(trigdata->tg_trigger->tgconstrrelid, RowShareLock);
  	pk_rel = trigdata->tg_relation;
***************
*** 1634,1640 ****
  					queryoids[i] = SPI_gettypeid(pk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_PK_IDX]);
  				}
! 				strcat(querystr, " FOR UPDATE OF x");
  
  				/* Prepare and save the plan */
  				qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
--- 1634,1640 ----
  					queryoids[i] = SPI_gettypeid(pk_rel->rd_att,
  									 qkey.keypair[i][RI_KEYPAIR_PK_IDX]);
  				}
! 				strcat(querystr, " FOR SHARE OF x");
  
  				/* Prepare and save the plan */
  				qplan = ri_PlanCheck(querystr, qkey.nkeypairs, queryoids,
